// Formily form base buttons -> submit, save etc.
//= require formily/base/form_response

$(document).ready(function() {

  var closeWindowFunc;

  if(window.parent == window.top && window.opener) {
    closeWindowFunc = function(str){
      window.opener.FormilyModal.close(str);
      window.close();
    }
  } else {
    closeWindowFunc = function(str){
      window.parent.FormilyModal.close(str);
    }
  }

  $(document).on('click', '#formily_save_and_close', function(e){
    var form = $(this).parents('form').get(0);
    $(':file', form).remove();
    form = $(this).parents('form');
    var formData = new FormData(form.get(0));

    if(isFormilyFileUploaded()){
      formData.append('save_and_close', true);

      $('.formily-spinner').show();

      $.ajax({
        url: form.attr('action'),
        type: 'POST',
        data: formData,
        dataType: 'json',
        success: function (data) {
          closeWindowFunc('formily_update_table');
          $('.formily-spinner').hide();
        },
        cache: false,
        contentType: false,
        processData: false
      });
    }

  });

  $(document).on('click', '#formily_cancel, .close-iframe-btn', function(e){
    if(isFormilyFileUploaded()) {
      closeWindowFunc('formily_update_table');
    }
  });

  $(document).on('click', '#cancel_add_form', function(e){
    if(isFormilyFileUploaded()){
      closeWindowFunc('formily_update_table');
    }
  });

  $(document).on('click', '.formily-edit', function(e){
    $('input, button, textarea, select').each(function(){
      $(this).attr('disabled', null);
    });
    $('.formily-edit').remove();
  });

  $(document).on('click', '#formily_delete', function(e){
    if(isFormilyFileUploaded()){
      var self = $(this);
      var id = self.data('formilyDeleteResponseId');
      var data = self.data('formilyResponse');

      if(confirm('Are you sure you want to delete the form submission?')){
        $.ajax({
          url: FormilyRoutes.response_delete_path(id),
          data: data,
          type: 'DELETE',
          success: function(){
            closeWindowFunc('formily_update_table');
          }
        });
      }
    }
  });

  $('#formily_form_tag').on('submit', function(e){
    var form = $(this);

    if(isFormilyFileUploaded()){
      if (validateRequiredFields(form)){
        $(':file', form).remove();
        form = $(this);
        var formData = new FormData(form.get(0));

        $('.formily-spinner').show();

        $.ajax({
          url: form.attr('action'),
          type: 'POST',
          data: formData,
          dataType: 'json',
          success: function (data) {
            closeWindowFunc('formily_update_table');
            $('.formily-spinner').show();
          },
          cache: false,
          contentType: false,
          processData: false
        });
      }
    }

    e.preventDefault();
    return false;
  });

  $(document).on('click', '.add_new_response', function(e){
    var self = $(this);
    var url = self.data('href');
    var data = self.data('params');

    $.ajax({
      url: url,
      type: 'POST',
      data: data,
      success: function(data){
        window.location.reload(true);
      }
    });

    e.preventDefault();
  });

  var validateRequiredFields = function(form) {
    var res = true;
    var errors = $('ul.errors');
    errors.children().remove();

    form.find("[data-required='required']").each(function(){
      var field = $(this);

      if(field.attr('name')) {

        if (field.attr('type') == 'text' || field.is('textarea')) {

          if (field.val().replace(/^\s*/, '') == "") {
            res = false;
            field.parent().addClass('has-errors');
          } else {
            field.parent().removeClass('has-errors');
          }

        } else if (field.attr('type') == 'file') {
          if (field.parent().find('span.label.secondary').length == 0
            && field.val() == "" && field.parent().parent().find('.file_upload').length == 0) {
            res = false;

            if (field.attr('multiple')) {
              field.parent().attr('class', 'alert');
              field.parent().parent().addClass('has-errors');
            } else {
              field.parent().addClass('has-errors');
            }
          } else {
            field.parent().removeClass('has-errors');
          }
        }
      }
    });

    if($(".has-errors").first().length > 0) {
      errors.append("<li>Please complete the highlighted required fields.</li>");
      errors.removeClass("hidden");

      $('html, body').animate({
        scrollTop: $(".has-errors").first().offset().top
      }, 1000);
    }

    return res;
  }
});
