(function() {
  
  var InputModel = function(){

    this.id = 0;
    this.name = '';
    this.type = '';
    this.label = '';
    this.description = '';
    this.field_order = '';
    this.default_value = '';
    this.tag_attributes = '';

    this.setValue = function(prop_name, value){
      if(this[prop_name] != undefined) {

        this[prop_name] = value;
      }
    };

    this.getBaseObj = function(){
      return {
        id: this.id,
        name: this.name,
        type: this.type,
        label: this.label,
        description: this.description,
        field_order: this.field_order,
        default_value: this.default_value,
        tag_attributes: this.tag_attributes
      }
    };

    this.getFromFieldset = function(fieldset){
      var self = this;
      fieldset.serializeArray().forEach(function(el){
        var name = el.name.replace(/inputs\[\](group_inputs\[\])?/i, '');
        self[name] = el.value;
      });
    };

    this.getTagAttr = function(){
      try{
        return JSON.parse(this.tag_attributes);
      }catch(e){
        return {};
      }
    };

    this.setTagAttr = function(name, data){
      var obj = this.getTagAttr();
      obj[name] = data;
      this.tag_attributes = JSON.stringify(obj);
    };

    this.delTagAttr = function(attr){
      var obj = this.getTagAttr();
      delete(obj[attr]);
      this.tag_attributes = JSON.stringify(obj);
    };

    this.clear = function(){
      this.id = 0;
      this.name = '';
      this.type = '';
      this.label = '';
      this.description = '';
      this.field_order = '';
      this.default_value = '';
      this.tag_attributes = '';
    };

  };

  window.InputModel = new InputModel();
})();
