// Formily modal window
(function() {

  var FormilyModal = function(){

    var modalContainer, modalIframe;
    this.callback = null;
    this.src = '';
    this.data = {};
    this.dataTable = null;

    this.show = function(src){
      this.src = modalIframe.attr('src', src);
      modalContainer.show();
    };

    this.close = function(trigger){
      if (trigger && trigger.length > 0) {
        this.data.resource_type = this.data.model_name;
        this.data.resource_id = this.data.model_id;

        $(document).trigger(trigger, this.data);
      }
      if(modalContainer) {
        $(modalIframe.get(0).contentDocument.body).html('<div class="formily-loading">Loading ...</div>');
        modalContainer.hide();
      }
    };

    this.runCallback = function(){
      this.callback(this);
    };

    this.initialize = function(){

      $(document).on('click', '[data-formily-iframe-url]', function() {

        var self = $(this);
        var arr = self.data('formilyIframeUrl').replace(/.*?\?/i,'').split('&');
        var m = self.data('formilyIframeUrl').match(/\/(\d+)/);

        if(m) {
          window.FormilyModal.data.form_id = m[1];
        }
        delete(window.FormilyModal.data.all);
        var tmp = null;

        arr.forEach(function(el){
          tmp = el.split('=');
          window.FormilyModal.data[tmp[0]] = tmp[1]
        });

        if(window.FormilyMobile.any()){
          window.open(self.data('formilyIframeUrl'));
          return false;
        }

        modalContainer = $('#formily_modal_container');
        modalIframe = modalContainer.find('#formily_iframe_modal iframe');

        modalContainer.show();
        modalIframe.attr('src', self.data('formilyIframeUrl'));

        var h = 500, w = 620;

        var div = modalIframe.parent();

        if (window.FormilyMobile.any()) {
        } else {
          div.css('height', h);
          div.css('width', w);
          div.css('margin-top', -(h/2));
          div.css('margin-left', -(w/2));
        }

        return false;
      });

      $(document).on('click', 'a.close-iframe-btn, #formily_modal_container', function(){

        if(window.parent.FormilyModal != undefined && window.top != window.parent){

          if(isFormilyFileUploaded()){
            window.parent.FormilyModal.close(false);
          }

        } else {
          if(modalIframe.get(0).contentWindow.isFormilyFileUploaded()){
            window.FormilyModal.close(false);
          }
        }

        return false;
      });

    };

  };

  if(typeof(window.FormilyModal) === 'undefined') {
    window.FormilyModal = new FormilyModal();
  }

})();
