# coding: utf-8

require 'formily/submitted_data_table'

class Formily::SubmitDataController < FormilyController

  before_action :set_layout, only: [:submitted_data, :data_table]

  # On formily form submit
  def submit
    submit = Formily::Submit.find_by(id: params[:submit_id])
    inputs_ids = []
    @form_id = params[:form_id]
    @resource_id = params[:resource_id]
    @resource_type = params[:resource_type]

    @save_and_close = params[:save_and_close].present?

    if params[:formily_inputs].present?

      params[:formily_inputs].each do |key, value|
        if value.is_a?(Hash)
          value.each do |k, v|
            inputs_ids << k
            iv = submit.input_values.find_or_create_by(input_id: k)

            if v.is_a?(Array)
              v.each do |av|
                f = iv.attach.build(input_value_id: iv.id)
                f.file = av
                f.save
                iv.input_value = f.file.original_filename
              end
            elsif v.respond_to?('original_filename')# Detect file
              f = iv.attach.build(input_value_id: iv.id)
              f.file = v
              f.save
              iv.input_value = f.file.original_filename
            else
              iv.input_value = v
            end

            if @save_and_close
              iv.save
            else
              if iv.input_value.blank?
                iv.destroy
              else
                iv.save
              end
            end
          end
        else
          inputs_ids << key
          iv = submit.input_values.find_or_create_by(input_id: key)

          if value.is_a?(Array)
            value.each do |av|
              f = iv.attach.build(input_value_id: iv.id)
              f.file = av
              f.save
              iv.input_value = f.file.original_filename
            end
          elsif value.respond_to?('original_filename')# Detect file
            f = iv.attach.build(input_value_id: iv.id)
            f.file = value
            f.save
            iv.input_value = f.file.original_filename
          else
            iv.input_value = value
          end

          if @save_and_close
            iv.save
          else
            if iv.input_value.blank?
              iv.destroy
            else
              iv.save
            end
          end

        end
      end

    end

    submit.input_values.where.not(input_id: inputs_ids).each do |iv|
      iv.destroy if iv.attach.count == 0 # don't remove files
    end

    if @save_and_close
      submit.update_column(:state, 1)
    else
      submit.update_column(:state, 2)
    end

  end

  def upload_file
    submit = Formily::Submit.find(params[:submit_id])
    iv = submit.input_values.find_or_create_by(input_id: params[:input_id], input_value: 'file')
    f = iv.attach.build(input_value_id: iv.id)
    f.file = params[:file]
    f.save

    render json: {file_id: f.id}, status: :ok
  end

  def submitted_data
    model = params[:model_name].safe_constantize
    model = model.find(params[:model_id])
    ids = model.formily_forms.pluck(:form_id)

    @forms = Formily::Form.where(id: ids)
    @model_name = params[:model_name]
    @model_id = params[:model_id]

    render partial: formily_partial_path('data/forms_table')
  end

  def data_table
    if params[:model_name] && params[:model_id]
      model = params[:model_name].safe_constantize
      model = model.find(params[:model_id])
      @res = model
    end

    @form = Formily::Form.find(params[:form_id])
    @not_manage = true
    @page_name = @form.title
    @data_table = Formily::SubmittedDataTable.new(@form, @res)

    respond_to do |format|
      format.html { render formily_partial_path('data/submit_data_table') }
      format.csv { send_data @data_table.to_csv, filename: "#{@form.id}_#{@form.title.parameterize.underscore}.csv" }
    end
  end

  def destroy_response
    submit = Formily::Submit.find(params[:id])
    submit.destroy

    render json: {}, status: :ok
  end

  private
    def set_layout
      if params[:iframe]
        @iframe = true
        Formily::SubmitDataController.layout("#{Formily.config.editor.css_style}_formily")
      else
        @iframe = false
        Formily::SubmitDataController.layout(ApplicationController.new.send(:_layout).virtual_path.split('/').last)
      end
    end

end
