# coding: utf-8
class Formily::FormilyableForm < ActiveRecord::Base

  self.table_name = 'formilyable_forms'

  has_paper_trail

  belongs_to :formilyable, polymorphic: true
  belongs_to :form, foreign_key: :form_id, class_name: 'Formily::Form'

  validates_uniqueness_of :form_id, :scope => [:formilyable_id, :formilyable_type]
  validates :form_id, :formilyable_id, :formilyable_type, presence: true

  def formily_title
    self.formilyable_type.safe_constantize.find(self.formilyable_id).formily_title rescue ''
  end

end
