# coding: utf-8
Rails.application.routes.draw do

  namespace :formily do

    resources :form_types

    resources :forms do
      collection do
        post 'add_new_response', action: :add_new_response, as: :add_new_response
        post 'preview/form', action: :preview
        post 'reload_formily_table', action: :reload_formily_table
      end
    end

    resources :formilyable, only: [:create, :destroy, :new]

    resources :inputs, only: [:destroy, :create, :update] do
      collection do
        post 'render_input_html', action: :render_input_html
        get 'render_related', action: :render_related
      end
    end

    resources :submit_data, only: [] do
      collection do
        post 'submit', action: :submit
        post 'upload_file', action: :upload_file
        delete 'destroy_response/:id', action: :destroy_response, as: :destroy_response
      end
    end

    resources :file, only: [:destroy]

    namespace :iframe do
      get 'forms/:id', to: 'forms#show',
          as: :form
    end

  end

end
