# coding: utf-8
module Formily
  class InstallGenerator < ::Rails::Generators::Base

    include Rails::Generators::Migration

    source_root File.expand_path('../templates', __FILE__)

    def install_assets
      insert_into_file 'config/initializers/assets.rb', after: ".js )\n" do
        "\nRails.application.config.assets.precompile += %w( formily.css formily.js formily_app.js formily_iframe.js foundation_formily.css formily_iframe.css )" +
        "\nRails.application.config.assets.precompile << /\\.(?:svg|eot|woff|ttf|otf)\\z/"
      end
    end

    def copy_initializer
      template "formily.rb", "config/initializers/formily.rb"
    end

    # def copy_locale
    #   copy_file "../../../config/locales/en.yml", "config/locales/formily.en.yml"
    # end

    def copy_migrations
      migration_template 'create_formily_forms.rb', 'db/migrate/create_formily_forms.rb'
      migration_template 'create_formily_data.rb', 'db/migrate/create_formily_data.rb'
      migration_template 'create_formily_inputs.rb', 'db/migrate/create_formily_inputs.rb'
      migration_template 'create_formilyable_forms.rb', 'db/migrate/create_formilyable_forms.rb'
      migration_template 'create_formily_files.rb', 'db/migrate/create_formily_files.rb'
      migration_template 'create_formily_form_types.rb', 'db/migrate/create_formily_form_types.rb'
    end

    def self.next_migration_number(path)
      unless @prev_migration_nr
        @prev_migration_nr = Time.now.utc.strftime('%Y%m%d%H%M%S').to_i
      else
        @prev_migration_nr += 1
      end
      @prev_migration_nr.to_s
    end

  end
end
